# std::basic_fstream< CharT, Traits > Class Template Reference

Controlling intput and output for files. More...

Inheritance diagram for std::basic_fstream< CharT, Traits >:

[legend]
Collaboration diagram for std::basic_fstream< CharT, Traits >:

[legend]
List of all members.

## Public Types

typedef CharT | char_type
typedef Traits | traits_type
typedef traits_type::int_type | int_type
typedef traits_type::pos_type | pos_type
typedef traits_type::off_type | off_type
typedef IosFmtflags | fmtflags
| This is a bitmask type.
typedef IosIostate | iostate
| This is a bitmask type.
typedef IosOpenmode | openmode
| This is a bitmask type.
typedef IosSeekdir | seekdir
| This is an enumerated type.
typedef void(* | event_callback )(event, ios_base &, int)
| The type of an event callback function.
enum | event
| The set of events that may be passed to an event callback. More...

## Public Member Functions

| basic_fstream ()
| Default constructor.
| basic_fstream (const char *s, ios_base::openmode __mode=ios_base::in|ios_base::out)
| Create an input/output file stream.
| ~basic_fstream ()
| The destructor does nothing.
__filebuf_type * | rdbuf () const
| Accessing the underlying buffer.
bool | is_open ()
| Wrapper to test for an open file.
void | open (const char *s, ios_base::openmode __mode=ios_base::in|ios_base::out)
| Opens an external file.
void | close ()
| Close the file.
streamsize | gcount () const
| Character counting.
iostate | rdstate () const
| Returns the error state of the stream buffer.
void | clear (iostate state=goodbit)
| [Re]sets the error state.
void | setstate (iostate state)
| Sets additional flags in the error state.
bool | good () const
| Fast error checking.
bool | eof () const
| Fast error checking.
bool | fail () const
| Fast error checking.
bool | bad () const
| Fast error checking.
iostate | exceptions () const
| Throwing exceptions on errors.
void | exceptions (iostate __except)
| Throwing exceptions on errors.
basic_ostream< CharT, Traits > * | tie () const
| Fetches the current tied stream.
basic_ostream< CharT, Traits > * | tie (basic_ostream< CharT, Traits > *__tiestr)
| Ties this stream to an output stream.
basic_streambuf< CharT, Traits > * | rdbuf (basic_streambuf< CharT, Traits > *sb)
| Changing the underlying buffer.
basic_ios & | copyfmt (const basic_ios &__rhs)
| Copies fields of __rhs into this.
char_type | fill () const
| Retreives the "empty" character.
char_type | fill (char_type ch)
| Sets a new "empty" character.
locale | imbue (const locale &__loc)
| Moves to a new locale.
char | narrow (char_type c, char __dfault) const
| Squeezes characters.
char_type | widen (char c) const
| Widens characters.
void | register_callback (event_callback __fn, int index)
| Add the callback __fn with parameter index.
fmtflags | flags () const
| Access to format flags.
fmtflags | flags (fmtflags __fmtfl)
| Setting new format flags all at once.
fmtflags | setf (fmtflags __fmtfl)
| Setting new format flags.
fmtflags | setf (fmtflags __fmtfl, fmtflags __mask)
| Setting new format flags.
void | unsetf (fmtflags __mask)
| Clearing format flags.
streamsize | precision () const
| Flags access.
streamsize | precision (streamsize __prec)
| Changing flags.
streamsize | width () const
| Flags access.
streamsize | width (streamsize __wide)
| Changing flags.
locale | getloc () const
| Locale access.
const locale & | M_getloc () const
| Locale access.
long & | iword (int __ix)
| Access to integer array.
void *& | pword (int __ix)
| Access to void pointer array.
__ostream_type & | flush ()
| Synchronizing the stream buffer.
pos_type | tellp ()
| Getting the current write position.
__ostream_type & | seekp (pos_type)
| Changing the current write position.
__ostream_type & | seekp (off_type, ios_base::seekdir)
| Changing the current write position.
__istream_type & | operator>> (__istream_type &(*__pf)(__istream_type &))
| Interface for manipulators.
__istream_type & | operator>> (__ios_type &(*__pf)(__ios_type &))
| Interface for manipulators.
__istream_type & | operator>> (ios_base &(*__pf)(ios_base &))
| Interface for manipulators.
Arithmetic Extractors

All the `operator>>` functions (aka formatted input functions) have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to false. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state without causing an ios_base::failure to be thrown. The original exception will then be rethrown.

__istream_type & | operator>> (bool &n)
| Basic arithmetic extractors.
__istream_type & | operator>> (short &n)
| Basic arithmetic extractors.
__istream_type & | operator>> (unsigned short &n)
| Basic arithmetic extractors.
__istream_type & | operator>> (int &n)
| Basic arithmetic extractors.
__istream_type & | operator>> (unsigned int &n)
| Basic arithmetic extractors.
__istream_type & | operator>> (long &n)
| Basic arithmetic extractors.
__istream_type & | operator>> (unsigned long &n)
| Basic arithmetic extractors.
__istream_type & | operator>> (float &__f)
| Basic arithmetic extractors.
__istream_type & | operator>> (double &__f)
| Basic arithmetic extractors.
__istream_type & | operator>> (long double &__f)
| Basic arithmetic extractors.
__istream_type & | operator>> (void *&__p)
| Basic arithmetic extractors.
__istream_type & | operator>> (streambuf_type *sb)
| Extracting into another streambuf.
Unformatted Input Functions

All the unformatted input functions have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to true. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

The number of characters extracted is stored for later retrieval by gcount().

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state without causing an ios_base::failure to be thrown. The original exception will then be rethrown.

int_type | get ()
| Simple extraction.
__istream_type & | get (char_type &c)
| Simple extraction.
__istream_type & | get (char_type *s, streamsize n, char_type __delim)
| Simple multiple-character extraction.
__istream_type & | get (char_type *s, streamsize n)
| Simple multiple-character extraction.
__istream_type & | get (streambuf_type &sb, char_type __delim)
| Extraction into another streambuf.
__istream_type & | get (streambuf_type &sb)
| Extraction into another streambuf.
__istream_type & | getline (char_type *s, streamsize n, char_type __delim)
| String extraction.
__istream_type & | getline (char_type *s, streamsize n)
| String extraction.
__istream_type & | ignore (streamsize n=1, int_type __delim=traits_type::eof())
| Discarding characters.
int_type | peek ()
| Looking ahead in the stream.
__istream_type & | read (char_type *s, streamsize n)
| Extraction without delimiters.
streamsize | readsome (char_type *s, streamsize n)
| Extraction until the buffer is exhausted, but no more.
__istream_type & | putback (char_type c)
| Unextracting a single character.
__istream_type & | unget ()
| Unextracting the previous character.
int | sync ()
| Synchronizing the stream buffer.
pos_type | tellg ()
| Getting the current read position.
__istream_type & | seekg (pos_type)
| Changing the current read position.
__istream_type & | seekg (off_type, ios_base::seekdir)
| Changing the current read position.
| operator void * () const
| The quick-and-easy status check.
bool | operator! () const
| The quick-and-easy status check.
__ostream_type & | operator<< (__ostream_type &(*__pf)(__ostream_type &))
| Interface for manipulators.
__ostream_type & | operator<< (__ios_type &(*__pf)(__ios_type &))
| Interface for manipulators.
__ostream_type & | operator<< (ios_base &(*__pf)(ios_base &))
| Interface for manipulators.
Arithmetic Inserters

All the `operator<<` functions (aka formatted output functions) have some common behavior. Each starts by constructing a temporary object of type std::basic_ostream::sentry. This can have several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to generate whatever data is appropriate for the type of the argument.

If an exception is thrown during insertion, ios_base::badbit will be turned on in the stream's error state without causing an ios_base::failure to be thrown. The original exception will then be rethrown.

__ostream_type & | operator<< (long n)
| Basic arithmetic inserters.
__ostream_type & | operator<< (unsigned long n)
| Basic arithmetic inserters.
__ostream_type & | operator<< (bool n)
| Basic arithmetic inserters.
__ostream_type & | operator<< (short n)
| Basic arithmetic inserters.
__ostream_type & | operator<< (unsigned short n)
| Basic arithmetic inserters.
__ostream_type & | operator<< (int n)
| Basic arithmetic inserters.
__ostream_type & | operator<< (unsigned int n)
| Basic arithmetic inserters.
__ostream_type & | operator<< (double __f)
| Basic arithmetic inserters.
__ostream_type & | operator<< (float __f)
| Basic arithmetic inserters.
__ostream_type & | operator<< (long double __f)
| Basic arithmetic inserters.
__ostream_type & | operator<< (const void *__p)
| Basic arithmetic inserters.
__ostream_type & | operator<< (streambuf_type *sb)
| Extracting from another streambuf.
Unformatted Output Functions

All the unformatted output functions have some common behavior. Each starts by constructing a temporary object of type std::basic_ostream::sentry. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to generate whatever data is appropriate for the type of the argument.

If an exception is thrown during insertion, ios_base::badbit will be turned on in the stream's error state. If badbit is on in the stream's exceptions mask, the exception will be rethrown without completing its actions.

__ostream_type & | put (char_type c)
| Simple insertion.
void | M_write (const char_type *s, streamsize n)
| Simple insertion.
__ostream_type & | write (const char_type *s, streamsize n)
| Character string insertion.

## Static Public Member Functions

bool | sync_with_stdio (bool sync=true)
| Interaction with the standard C I/O objects.
int | xalloc () throw ()
| Access to unique indices.

## Static Public Attributes

const fmtflags | boolalpha
| Insert/extract `bool` in alphabetic rather than numeric format.
const fmtflags | dec
| Converts integer input or generates integer output in decimal base.
const fmtflags | fixed
| Generate floating-point output in fixed-point notation.
const fmtflags | hex
| Converts integer input or generates integer output in hexadecimal base.
const fmtflags | internal
| Adds fill characters at a designated internal point in certain generated output, or identical to `right` if no such point is designated.
const fmtflags | left
| Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.).
const fmtflags | oct
| Converts integer input or generates integer output in octal base.
const fmtflags | right
| Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.).
const fmtflags | scientific
| Generates floating-point output in scientific notation.
const fmtflags | showbase
| Generates a prefix indicating the numeric base of generated integer output.
const fmtflags | showpoint
| Generates a decimal-point character unconditionally in generated floating-point output.
const fmtflags | showpos
| Generates a + sign in non-negative generated numeric output.
const fmtflags | skipws
| Skips leading white space before certain input operations.
const fmtflags | unitbuf
| Flushes output after each output operation.
const fmtflags | uppercase
| Replaces certain lowercase letters with their uppercase equivalents in generated output.
const fmtflags | adjustfield
| A mask of left|right|internal. Useful for the 2-arg form of `setf`.
const fmtflags | basefield
| A mask of dec|oct|hex. Useful for the 2-arg form of `setf`.
const fmtflags | floatfield
| A mask of scientific|fixed. Useful for the 2-arg form of `setf`.
const iostate | badbit
| Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file).
const iostate | eofbit
| Indicates that an input operation reached the end of an input sequence.
const iostate | failbit
| Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters.
const iostate | goodbit
| Indicates all is well.
const openmode | app
| Seek to end before each write.
const openmode | ate
| Open and seek to end immediately after opening.
const openmode | binary
| Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#3 and http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#7 for more.
const openmode | in
| Open for input. Default for `ifstream` and fstream.
const openmode | out
| Open for output. Default for `ofstream` and fstream.
const openmode | trunc
| Open for input. Default for `ofstream`.
const seekdir | beg
| Request a seek relative to the beginning of the stream.
const seekdir | cur
| Request a seek relative to the current position within the sequence.
const seekdir | end
| Request a seek relative to the current end of the sequence.

## Protected Member Functions

void | init (basic_streambuf< CharT, Traits > *sb)
| All setup is performed here.

## Detailed Description

### template<typename CharT, typename Traits>
class std::basic_fstream< CharT, Traits >

Controlling intput and output for files.

This class supports reading from and writing to named files, using the inherited functions from std::basic_iostream. To control the associated sequence, an instance of std::basic_filebuf is used, which this page refers to as `sb`.

Definition at line 757 of file fstream.

## Member Typedef Documentation

template<typename CharT, typename Traits>
typedef CharT std::basic_fstream< CharT, Traits >::char_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_iostream< CharT, Traits >. Definition at line 761 of file fstream.

typedef void(* std::ios_base::event_callback)(event, ios_base &, int)`[inherited]`

The type of an event callback function.

Parameters:

  | event | One of the members of the event enum.
  | ios_base | Reference to the ios_base object.
  | int | The integer provided when the callback was registered.

Event callbacks are user defined functions that get called during several ios_base and basic_ios functions, specifically imbue(), copyfmt(), and ~ios().

Definition at line 394 of file ios_base.h.

Referenced by std::ios_base::register_callback().

typedef IosFmtflags std::ios_base::fmtflags`[inherited]`

This is a bitmask type.

`"IosFmtflags"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type fmtflags are:

- boolalpha
- dec
- fixed
- hex
- internal
- left
- oct
- right
- scientific
- showbase
- showpoint
- showpos
- skipws
- unitbuf
- uppercase
- adjustfield
- basefield
- floatfield

Definition at line 210 of file ios_base.h.

Referenced by std::num_get< CharT, InIter >::do_get(), std::num_put< CharT, OutIter >::do_put(), std::basic_ostream< CharT, Traits >::operator<<(), std::basic_ostream< char >::operator<<(), and std::resetiosflags().

template<typename CharT, typename Traits>
typedef traits_type::int_type std::basic_fstream< CharT, Traits >::int_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_iostream< CharT, Traits >. Definition at line 763 of file fstream.

typedef IosIostate std::ios_base::iostate`[inherited]`

This is a bitmask type.

`"IosIostate"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type iostate are:

- badbit
- eofbit
- failbit
- goodbit

Definition at line 285 of file ios_base.h.

Referenced by std::money_get< CharT, InIter >::get(), std::num_get< CharT, InIter >::get(), std::time_get< CharT, InIter >::get_time(), std::basic_ostream< CharT, Traits >::operator<<(), std::basic_istream< CharT, Traits >::operator>>(), std::operator>>(), and std::basic_istream< CharT, Traits >::sentry::sentry().

template<typename CharT, typename Traits>
typedef traits_type::off_type std::basic_fstream< CharT, Traits >::off_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_iostream< CharT, Traits >. Definition at line 765 of file fstream.

typedef IosOpenmode std::ios_base::openmode`[inherited]`

This is a bitmask type.

`"IosOpenmode"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type openmode are:

- app
- ate
- binary
- in
- out
- trunc

Definition at line 316 of file ios_base.h.

Referenced by std::basic_ifstream< CharT, Traits >::basic_ifstream(), std::basic_ofstream< CharT, Traits >::basic_ofstream(), std::basic_streambuf< CharT, enc_char_traits< CharT > >::pubseekoff(), std::basic_fstream< CharT, Traits >::rdbuf(), and __gnu_cxx::stdio_filebuf< CharT, Traits >::stdio_filebuf().

template<typename CharT, typename Traits>
typedef traits_type::pos_type std::basic_fstream< CharT, Traits >::pos_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_iostream< CharT, Traits >. Definition at line 764 of file fstream.

typedef IosSeekdir std::ios_base::seekdir`[inherited]`

This is an enumerated type.

`"IosSeekdir"` is implementation-defined. Defined values of type seekdir are:

- beg
- cur, equivalent to `SEEKCUR` in the C standard library.
- end, equivalent to `SEEKEND` in the C standard library.

Definition at line 349 of file ios_base.h.

Referenced by std::basic_streambuf< CharT, enc_char_traits< CharT > >::pubseekoff(), std::basic_istream< CharT, Traits >::seekg(), std::basic_stringbuf< CharT, Traits, Alloc >::seekoff(), std::basic_filebuf< CharT, Traits >::seekoff(), and std::basic_ostream< CharT, Traits >::seekp().

template<typename CharT, typename Traits>
typedef Traits std::basic_fstream< CharT, Traits >::traits_type

| These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation. Reimplemented from std::basic_iostream< CharT, Traits >. Definition at line 762 of file fstream.

## Member Enumeration Documentation

enum std::ios_base::event`[inherited]`

| The set of events that may be passed to an event callback. erase_event is used during ~ios() and copyfmt(). imbue_event is used during imbue(). copyfmt_event is used during copyfmt(). Definition at line 377 of file ios_base.h.

## Constructor & Destructor Documentation

template<typename CharT, typename Traits>
std::basic_fstream< CharT, Traits >::basic_fstream | ( |  | ) | `[inline]`

| Default constructor. Initializes `sb` using its default constructor, and passes `&sb` to the base class initializer. Does not open any files (you haven't given it a filename to open). Definition at line 790 of file fstream. References std::basic_fstream< CharT, Traits >::open().

template<typename CharT, typename Traits>
std::basic_fstream< CharT, Traits >::basic_fstream | ( | const char * | s,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out`
| ) | `[inline, explicit]`

Create an input/output file stream.

Parameters:

  | s | Null terminated string specifying the filename.
  | mode | Open file in specified mode (see std::ios_base).

Tip: When using std::string to hold the filename, you must use .c_str() before passing it to this constructor.

Definition at line 803 of file fstream.

template<typename CharT, typename Traits>
std::basic_fstream< CharT, Traits >::~basic_fstream | ( |  | ) | `[inline]`

| The destructor does nothing. The file is closed by the filebuf object, not the formatting stream. Definition at line 817 of file fstream.

## Member Function Documentation

template<typename CharT, typename Traits>
bool std::basic_ios< CharT, Traits >::bad | ( |  | ) | const`[inline, inherited]`

Fast error checking.

Returns:
  True if the badbit is set.

Note that other iostate flags may also be set.

Definition at line 197 of file basic_ios.h.

template<typename CharT, typename Traits>
void std::basic_ios< CharT, Traits >::clear | ( | iostate | state = `goodbit` | ) | `[inherited]`

[Re]sets the error state.

Parameters:

  | state | The new state flag(s) to set.

See std::ios_base::iostate for the possible bit values. Most users will not need to pass an argument.

Definition at line 39 of file basic_ios.tcc.

References std::basic_ios< CharT, Traits >::exceptions(), std::basic_ios< CharT, Traits >::rdbuf(), and std::basic_ios< CharT, Traits >::rdstate().

Referenced by std::basic_ios< CharT, Traits >::rdbuf().

template<typename CharT, typename Traits>
void std::basic_fstream< CharT, Traits >::close | ( |  | ) | `[inline]`

| Close the file. Calls `std::basic_filebuf::close()`. If that function fails, `failbit` is set in the stream's error state. Definition at line 864 of file fstream.

template<typename CharT, typename Traits>
basic_ios< CharT, Traits > & std::basic_ios< CharT, Traits >::copyfmt | ( | const basic_ios< CharT, Traits > & | __rhs | ) | `[inherited]`

Copies fields of __rhs into this.

Parameters:

  | __rhs | The source values for the copies.

Returns:
  Reference to this object.

All fields of __rhs are copied into this object except that rdbuf() and rdstate() remain unchanged. All values in the pword and iword arrays are copied. Before copying, each callback is invoked with erase_event. After copying, each (new) callback is invoked with copyfmt_event. The final step is to copy exceptions().

Definition at line 61 of file basic_ios.tcc.

References std::basic_ios< CharT, Traits >::exceptions(), std::basic_ios< CharT, Traits >::fill(), std::ios_base::flags(), std::ios_base::getloc(), std::ios_base::precision(), std::basic_ios< CharT, Traits >::tie(), and std::ios_base::width().

template<typename CharT, typename Traits>
bool std::basic_ios< CharT, Traits >::eof | ( |  | ) | const`[inline, inherited]`

Fast error checking.

Returns:
  True if the eofbit is set.

Note that other iostate flags may also be set.

Definition at line 176 of file basic_ios.h.

template<typename CharT, typename Traits>
void std::basic_ios< CharT, Traits >::exceptions | ( | iostate | __except | ) | `[inline, inherited]`

Throwing exceptions on errors.

Parameters:

  | except | The new exceptions mask.

By default, error flags are set silently. You can set an exceptions mask for each stream; if a bit in the mask becomes set in the error flags, then an exception of type std::ios_base::failure is thrown.

If the error flage is already set when the exceptions mask is added, the exception is immediately thrown. Try running the following under GCC 3.1 or later:

      #include <iostream>
      #include <fstream>
      #include <exception>

      int main()
      {
          std::set_terminate (__gnu_cxx::__verbose_terminate_handler);

          std::ifstream f ("/etc/motd");

          std::cerr << "Setting badbit\n";
          f.setstate (std::ios_base::badbit);

          std::cerr << "Setting exception mask\n";
          f.exceptions (std::ios_base::badbit);
      }

Definition at line 243 of file basic_ios.h.

template<typename CharT, typename Traits>
iostate std::basic_ios< CharT, Traits >::exceptions | ( |  | ) | const`[inline, inherited]`

Throwing exceptions on errors.

Returns:
  The current exceptions mask.

This changes nothing in the stream. See the one-argument version of exceptions(iostate) for the meaning of the return value.

Definition at line 208 of file basic_ios.h.

Referenced by std::basic_ios< CharT, Traits >::clear(), and std::basic_ios< CharT, Traits >::copyfmt().

template<typename CharT, typename Traits>
bool std::basic_ios< CharT, Traits >::fail | ( |  | ) | const`[inline, inherited]`

Fast error checking.

Returns:
  True if either the badbit or the failbit is set.

Checking the badbit in fail() is historical practice. Note that other iostate flags may also be set.

Definition at line 187 of file basic_ios.h.

Referenced by std::basic_ios< char, Traits >::operator void *(), std::basic_ios< char, Traits >::operator!(), std::basic_istream< CharT, Traits >::seekg(), std::basic_ostream< CharT, Traits >::seekp(), std::basic_istream< CharT, Traits >::tellg(), and std::basic_ostream< CharT, Traits >::tellp().

template<typename CharT, typename Traits>
char_type std::basic_ios< CharT, Traits >::fill | ( | char_type | ch | ) | `[inline, inherited]`

Sets a new "empty" character.

Parameters:

  | ch | The new character.

Returns:
  The previous fill character.

The fill character is used to fill out space when P+ characters have been requested (e.g., via setw), Q characters are actually used, and Q<P. It defaults to a space (' ') in the current locale.

Definition at line 376 of file basic_ios.h.

template<typename CharT, typename Traits>
char_type std::basic_ios< CharT, Traits >::fill | ( |  | ) | const`[inline, inherited]`

Retreives the "empty" character.

Returns:
  The current fill character.

It defaults to a space (' ') in the current locale.

Definition at line 356 of file basic_ios.h.

Referenced by std::basic_ios< CharT, Traits >::copyfmt(), std::basic_ios< char, Traits >::fill(), and std::basic_ostream< CharT, Traits >::operator<<().

fmtflags std::ios_base::flags | ( | fmtflags | __fmtfl | ) | `[inline, inherited]`

Setting new format flags all at once.

Parameters:

  | fmtfl | The new flags to set.

Returns:
  The previous format control flags.

This function overwrites all the format flags with fmtfl.

Definition at line 517 of file ios_base.h.

fmtflags std::ios_base::flags | ( |  | ) | const`[inline, inherited]`

Access to format flags.

Returns:
  The format control flags for both input and output.

Definition at line 507 of file ios_base.h.

Referenced by std::basic_ios< CharT, Traits >::copyfmt(), std::num_get< CharT, InIter >::do_get(), std::num_put< CharT, OutIter >::do_put(), std::basic_ostream< CharT, Traits >::operator<<(), std::basic_ostream< char >::operator<<(), std::operator<<(), and std::basic_istream< CharT, Traits >::sentry::sentry().

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::flush | ( |  | ) | `[inherited]`

Synchronizing the stream buffer.

Returns:
  *this

If `rdbuf()` is a null pointer, changes nothing.

Otherwise, calls `rdbuf()->pubsync()`, and if that returns -1, sets badbit.

Definition at line 382 of file ostream.tcc.

References std::basic_ios< CharT, Traits >::rdbuf().

Referenced by std::flush().

template<typename CharT, typename Traits>
streamsize std::basic_istream< CharT, Traits >::gcount | ( |  | ) | const`[inline, inherited]`

Character counting.

Returns:
  The number of characters extracted by the previous unformatted input function dispatched for this stream.

Definition at line 241 of file istream.

template<typename CharT, typename Traits>
__istream_type& std::basic_istream< CharT, Traits >::get | ( | streambuf_type & | sb | ) | `[inline, inherited]`

Extraction into another streambuf.

Parameters:

  | sb | A streambuf in which to store data.

Returns:
  *this

Returns `get`(sb,widen('
')).

Definition at line 358 of file istream.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::get | ( | streambuf_type & | sb,
|  | char_type | __delim
| ) | `[inherited]`

Extraction into another streambuf.

Parameters:

  | sb | A streambuf in which to store data.
  | delim | A "stop" character.

Returns:
  *this

Characters are extracted and inserted into sb until one of the following happens:

- the input sequence reaches EOF
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted)
- the next character equals delim (in this case, the character is not extracted)
- an exception occurs (and in this case is caught)

If no characters are stored, failbit is set in the stream's error state.

Definition at line 542 of file istream.tcc.

References std::basic_istream< CharT, Traits >::char_type, std::basic_istream< CharT, Traits >::int_type, and std::basic_ios< CharT, Traits >::rdbuf().

template<typename CharT, typename Traits>
__istream_type& std::basic_istream< CharT, Traits >::get | ( | char_type * | s,
|  | streamsize | n
| ) | `[inline, inherited]`

Simple multiple-character extraction.

Parameters:

  | s | Pointer to an array.
  | n | Maximum number of characters to store in s.

Returns:
  *this

Returns `get`(s,n,widen('
')).

Definition at line 325 of file istream.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::get | ( | char_type * | s,
|  | streamsize | n,
|  | char_type | __delim
| ) | `[inherited]`

Simple multiple-character extraction.

Parameters:

  | s | Pointer to an array.
  | n | Maximum number of characters to store in s.
  | delim | A "stop" character.

Returns:
  *this

Characters are extracted and stored into s until one of the following happens:

- `n-1` characters are stored
- the input sequence reaches EOF
- the next character equals delim, in which case the character is not extracted

If no characters are stored, failbit is set in the stream's error state.

In any case, a null character is stored into the next location in the array.

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 503 of file istream.tcc.

References std::basic_istream< CharT, Traits >::char_type, std::basic_istream< CharT, Traits >::int_type, and std::basic_ios< CharT, Traits >::rdbuf().

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::get | ( | char_type & | c | ) | `[inherited]`

Simple extraction.

Parameters:

  | c | The character in which to store data.

Returns:
  *this

Tries to extract a character and store it in c. If none are available, sets failbit and returns traits::eof().

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 471 of file istream.tcc.

References std::basic_istream< CharT, Traits >::char_type, std::basic_istream< CharT, Traits >::int_type, and std::basic_ios< CharT, Traits >::rdbuf().

template<typename CharT, typename Traits>
basic_istream< CharT, Traits >::int_type std::basic_istream< CharT, Traits >::get | ( |  | ) | `[inherited]`

Simple extraction.

Returns:
  A character, or eof().

Tries to extract a character. If none are available, sets failbit and returns traits::eof().

Definition at line 440 of file istream.tcc.

References std::basic_istream< CharT, Traits >::int_type, and std::basic_ios< CharT, Traits >::rdbuf().

Referenced by std::basic_istream< char >::get().

template<typename CharT, typename Traits>
__istream_type& std::basic_istream< CharT, Traits >::getline | ( | char_type * | s,
|  | streamsize | n
| ) | `[inline, inherited]`

String extraction.

Parameters:

  | s | A character array in which to store the data.
  | n | Maximum number of characters to extract.

Returns:
  *this

Returns `getline`(s,n,widen('
')).

Definition at line 398 of file istream.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::getline | ( | char_type * | s,
|  | streamsize | n,
|  | char_type | __delim
| ) | `[inherited]`

String extraction.

Parameters:

  | s | A character array in which to store the data.
  | n | Maximum number of characters to extract.
  | delim | A "stop" character.

Returns:
  *this

Extracts and stores characters into s until one of the following happens. Note that these criteria are required to be tested in the order listed here, to allow an input line to exactly fill the s array without setting failbit.

1. the input sequence reaches end-of-file, in which case eofbit is set in the stream error state
2. the next character equals `delim`, in which case the character is extracted (and therefore counted in `gcount()`) but not stored
3. `n-1` characters are stored, in which case failbit is set in the stream error state

If no characters are extracted, failbit is set. (An empty line of input should therefore not cause failbit to be set.)

In any case, a null character is stored in the next location in the array.

Definition at line 581 of file istream.tcc.

References std::basic_istream< CharT, Traits >::char_type, std::basic_istream< CharT, Traits >::int_type, std::min(), std::basic_ios< CharT, Traits >::rdbuf(), and std::streamsize.

locale std::ios_base::getloc | ( |  | ) | const`[inline, inherited]`

Locale access.

Returns:
  A copy of the current locale.

If `imbue(loc)` has previously been called, then this function returns `loc`. Otherwise, it returns a copy of `std::locale()`, the global C++ locale.

Definition at line 649 of file ios_base.h.

Referenced by std::basic_ios< CharT, Traits >::copyfmt(), std::money_put< CharT, OutIter >::do_put(), std::operator>>(), and std::ws().

template<typename CharT, typename Traits>
bool std::basic_ios< CharT, Traits >::good | ( |  | ) | const`[inline, inherited]`

Fast error checking.

Returns:
  True if no error flags are set.

A wrapper around rdstate.

Definition at line 166 of file basic_ios.h.

Referenced by std::basic_ostream< CharT, Traits >::sentry::sentry(), and std::basic_istream< CharT, Traits >::sentry::sentry().

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::ignore | ( | streamsize | n = `1`,
|  | int_type | __delim = `traits_type::eof()`
| ) | `[inherited]`

Discarding characters.

Parameters:

  | n | Number of characters to discard.
  | delim | A "stop" character.

Returns:
  *this

Extracts characters and throws them away until one of the following happens:

- if n `!=` `std::numeric_limits<int>::max()`, n characters are extracted
- the input sequence reaches end-of-file
- the next character equals delim (in this case, the character is extracted); note that this condition will never occur if delim equals `traits::eof()`.

Definition at line 647 of file istream.tcc.

References std::basic_istream< CharT, Traits >::int_type, and std::basic_ios< CharT, Traits >::rdbuf().

template<typename CharT, typename Traits>
locale std::basic_ios< CharT, Traits >::imbue | ( | const locale & | __loc | ) | `[inherited]`

Moves to a new locale.

Parameters:

  | loc | The new locale.

Returns:
  The previous locale.

Calls `ios_base::imbue(loc)`, and if a stream buffer is associated with this stream, calls that buffer's `pubimbue(loc)`.

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Reimplemented from std::ios_base.

Definition at line 127 of file basic_ios.tcc.

References std::basic_ios< CharT, Traits >::rdbuf().

Referenced by std::operator<<().

template<typename CharT, typename Traits>
void std::basic_ios< CharT, Traits >::init | ( | basic_streambuf< CharT, Traits > * | sb | ) | `[protected, inherited]`

| All setup is performed here. This is called from the public constructor. It is not virtual and cannot be redefined. Definition at line 139 of file basic_ios.tcc.

template<typename CharT, typename Traits>
bool std::basic_fstream< CharT, Traits >::is_open | ( |  | ) | `[inline]`

Wrapper to test for an open file.

Returns:
  `rdbuf()->is_open()`

Definition at line 836 of file fstream.

long& std::ios_base::iword | ( | int | __ix | ) | `[inline, inherited]`

Access to integer array.

Parameters:

  | __ix | Index into the array.

Returns:
  A reference to an integer associated with the index.

The iword function provides access to an array of integers that can be used for any purpose. The array grows as required to hold the supplied index. All integers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 693 of file ios_base.h.

const locale& std::ios_base::M_getloc | ( |  | ) | const`[inline, inherited]`

Locale access.

Returns:
  A reference to the current locale.

Like getloc above, but returns a reference instead of generating a copy.

Definition at line 659 of file ios_base.h.

template<typename CharT, typename Traits>
void std::basic_ostream< CharT, Traits >::M_write | ( | const char_type * | s,
|  | streamsize | n
| ) | `[inline, inherited]`

Simple insertion.

Parameters:

  | c | The character to insert.

Returns:
  *this

Tries to insert c.

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 286 of file ostream.

template<typename CharT, typename Traits>
char std::basic_ios< CharT, Traits >::narrow | ( | char_type | c,
|  | char | __dfault
| ) | const`[inherited]`

Squeezes characters.

Parameters:

  | c | The character to narrow.
  | dfault | The character to narrow.

Returns:
  The narrowed character.

Maps a character of `char_type` to a character of `char`, if possible.

Returns the result of

        std::use_facet<ctype<char_type> >(getloc()).narrow(c,dfault)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Definition at line 116 of file basic_ios.tcc.

template<typename CharT, typename Traits>
void std::basic_fstream< CharT, Traits >::open | ( | const char * | s,
|  | ios_base::openmode | __mode = `ios_base::in | ios_base::out`
| ) | `[inline]`

Opens an external file.

Parameters:

  | s | The name of the file.
  | mode | The open mode flags.

Calls `std::basic_filebuf::open(s,mode)`. If that function fails, `failbit` is set in the stream's error state.

Tip: When using std::string to hold the filename, you must use .c_str() before passing it to this constructor.

Definition at line 850 of file fstream.

Referenced by std::basic_fstream< CharT, Traits >::basic_fstream(), and std::basic_fstream< CharT, Traits >::rdbuf().

template<typename CharT, typename Traits>
std::basic_ios< CharT, Traits >::operator void * | ( |  | ) | const`[inline, inherited]`

| The quick-and-easy status check. This allows you to write constructs such as "if (!a_stream) ..." and "while (a_stream) ..." Definition at line 107 of file basic_ios.h.

template<typename CharT, typename Traits>
bool std::basic_ios< CharT, Traits >::operator! | ( |  | ) | const`[inline, inherited]`

| The quick-and-easy status check. This allows you to write constructs such as "if (!a_stream) ..." and "while (a_stream) ..." Definition at line 111 of file basic_ios.h.

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::operator<< | ( | streambuf_type * | sb | ) | `[inherited]`

Extracting from another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from sb and inserted into `*this` until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output sequence fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs while getting a character from sb, which sets failbit in the error state

If the function inserts no characters, failbit is set.

Definition at line 306 of file ostream.tcc.

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::operator<< | ( | const void * | __p | ) | `[inherited]`

Basic arithmetic inserters.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to perform numeric formatting.

Definition at line 283 of file ostream.tcc.

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::operator<< | ( | long double | __f | ) | `[inherited]`

Basic arithmetic inserters.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to perform numeric formatting.

Definition at line 260 of file ostream.tcc.

template<typename CharT, typename Traits>
__ostream_type& std::basic_ostream< CharT, Traits >::operator<< | ( | float | __f | ) | `[inline, inherited]`

Basic arithmetic inserters.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to perform numeric formatting.

Definition at line 218 of file ostream.

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::operator<< | ( | double | __f | ) | `[inherited]`

Basic arithmetic inserters.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to perform numeric formatting.

Definition at line 237 of file ostream.tcc.

template<typename CharT, typename Traits>
__ostream_type& std::basic_ostream< CharT, Traits >::operator<< | ( | unsigned int | n | ) | `[inline, inherited]`

Basic arithmetic inserters.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to perform numeric formatting.

Definition at line 203 of file ostream.

template<typename CharT, typename Traits>
__ostream_type& std::basic_ostream< CharT, Traits >::operator<< | ( | int | n | ) | `[inline, inherited]`

Basic arithmetic inserters.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to perform numeric formatting.

Definition at line 192 of file ostream.

template<typename CharT, typename Traits>
__ostream_type& std::basic_ostream< CharT, Traits >::operator<< | ( | unsigned short | n | ) | `[inline, inherited]`

Basic arithmetic inserters.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to perform numeric formatting.

Definition at line 188 of file ostream.

template<typename CharT, typename Traits>
__ostream_type& std::basic_ostream< CharT, Traits >::operator<< | ( | short | n | ) | `[inline, inherited]`

Basic arithmetic inserters.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to perform numeric formatting.

Definition at line 177 of file ostream.

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::operator<< | ( | bool | n | ) | `[inherited]`

Basic arithmetic inserters.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to perform numeric formatting.

Definition at line 97 of file ostream.tcc.

References std::ios_base::iostate.

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::operator<< | ( | unsigned long | n | ) | `[inherited]`

Basic arithmetic inserters.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to perform numeric formatting.

Definition at line 154 of file ostream.tcc.

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::operator<< | ( | long | n | ) | `[inherited]`

Basic arithmetic inserters.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to perform numeric formatting.

Definition at line 120 of file ostream.tcc.

References std::basic_ostream< CharT, Traits >::char_type, std::basic_ios< CharT, Traits >::fill(), std::ios_base::flags(), and std::ios_base::fmtflags.

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::operator<< | ( | ios_base &(* | __pf)(ios_base &) | ) | `[inline, inherited]`

| Interface for manipulators. Manuipulators such as `std::endl` and `std::hex` use these functions in constructs like "std::cout << std::endl". For more information, see the iomanip header. Definition at line 85 of file ostream.tcc.

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::operator<< | ( | __ios_type &(* | __pf)(__ios_type &) | ) | `[inline, inherited]`

| Interface for manipulators. Manuipulators such as `std::endl` and `std::hex` use these functions in constructs like "std::cout << std::endl". For more information, see the iomanip header. Definition at line 73 of file ostream.tcc.

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::operator<< | ( | __ostream_type &(* | __pf)(__ostream_type &) | ) | `[inline, inherited]`

| Interface for manipulators. Manuipulators such as `std::endl` and `std::hex` use these functions in constructs like "std::cout << std::endl". For more information, see the iomanip header. Definition at line 62 of file ostream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | streambuf_type * | sb | ) | `[inherited]`

Extracting into another streambuf.

Parameters:

  | sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry object and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 416 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | void *& | __p | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 394 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | long double & | __f | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 372 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | double & | __f | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 350 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | float & | __f | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 328 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | unsigned long & | n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 260 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | long & | n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 238 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | unsigned int & | n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 216 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | int & | n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 185 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | unsigned short & | n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 163 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | short & | n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 132 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | bool & | n | ) | `[inherited]`

Basic arithmetic extractors.

Parameters:

  | A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 110 of file istream.tcc.

References std::ios_base::iostate.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | ios_base &(* | __pf)(ios_base &) | ) | `[inline, inherited]`

| Interface for manipulators. Manuipulators such as `std::ws` and `std::dec` use these functions in constructs like "std::cin >> std::ws". For more information, see the iomanip header. Definition at line 101 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | __ios_type &(* | __pf)(__ios_type &) | ) | `[inline, inherited]`

| Interface for manipulators. Manuipulators such as `std::ws` and `std::dec` use these functions in constructs like "std::cin >> std::ws". For more information, see the iomanip header. Definition at line 92 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::operator>> | ( | __istream_type &(* | __pf)(__istream_type &) | ) | `[inline, inherited]`

| Interface for manipulators. Manuipulators such as `std::ws` and `std::dec` use these functions in constructs like "std::cin >> std::ws". For more information, see the iomanip header. Definition at line 86 of file istream.tcc.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits >::int_type std::basic_istream< CharT, Traits >::peek | ( |  | ) | `[inherited]`

Looking ahead in the stream.

Returns:
  The next character, or eof().

If, after constructing the sentry object, `good()` is false, returns `traits::eof()`. Otherwise reads but does not extract the next input character.

Definition at line 683 of file istream.tcc.

References std::basic_istream< CharT, Traits >::int_type, and std::basic_ios< CharT, Traits >::rdbuf().

streamsize std::ios_base::precision | ( | streamsize | __prec | ) | `[inline, inherited]`

Changing flags.

Parameters:

  | prec | The new precision value.

Returns:
  The previous value of precision().

Definition at line 585 of file ios_base.h.

References std::streamsize.

streamsize std::ios_base::precision | ( |  | ) | const`[inline, inherited]`

Flags access.

Returns:
  The precision to generate on certain output operations.

Definition at line 577 of file ios_base.h.

Referenced by std::basic_ios< CharT, Traits >::copyfmt(), and std::operator<<().

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::put | ( | char_type | c | ) | `[inherited]`

Simple insertion.

Parameters:

  | c | The character to insert.

Returns:
  *this

Tries to insert c.

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 330 of file ostream.tcc.

References std::basic_ostream< CharT, Traits >::int_type, and std::basic_ios< CharT, Traits >::rdbuf().

Referenced by std::endl(), and std::ends().

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::putback | ( | char_type | c | ) | `[inherited]`

Unextracting a single character.

Parameters:

  | c | The character to push back into the input stream.

Returns:
  *this

If `rdbuf()` is not null, calls `rdbuf()->sputbackc(c)`.

If `rdbuf()` is null or if `sputbackc()` fails, sets badbit in the error state.

Note:
  Since no characters are extracted, the next call to `gcount()` will return 0, as required by DR 60.

Definition at line 759 of file istream.tcc.

References std::basic_istream< CharT, Traits >::int_type, and std::basic_ios< CharT, Traits >::rdbuf().

Referenced by std::operator>>().

void*& std::ios_base::pword | ( | int | __ix | ) | `[inline, inherited]`

Access to void pointer array.

Parameters:

  | __ix | Index into the array.

Returns:
  A reference to a void* associated with the index.

The pword function provides access to an array of pointers that can be used for any purpose. The array grows as required to hold the supplied index. All pointers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 714 of file ios_base.h.

References std::ios_base::pword().

Referenced by std::ios_base::pword().

template<typename CharT, typename Traits>
basic_streambuf< CharT, Traits > * std::basic_ios< CharT, Traits >::rdbuf | ( | basic_streambuf< CharT, Traits > * | sb | ) | `[inherited]`

Changing the underlying buffer.

Parameters:

  | sb | The new stream buffer.

Returns:
  The previous stream buffer.

Associates a new buffer with the current stream, and clears the error state.

Due to historical accidents which the LWG refuses to correct, the I/O library suffers from a design error: this function is hidden in derived classes by overrides of the zero-argument `rdbuf()`, which is non-virtual for hysterical raisins. As a result, you must use explicit qualifications to access this function via any derived class. For example:

      std::fstream     foo;         // or some other derived type
      std::streambuf*  p = .....;

      foo.ios::rdbuf(p);            // ios == basic_ios<char>

Definition at line 51 of file basic_ios.tcc.

References std::basic_ios< CharT, Traits >::clear().

template<typename CharT, typename Traits>
__filebuf_type* std::basic_fstream< CharT, Traits >::rdbuf | ( |  | ) | const`[inline]`

Accessing the underlying buffer.

Returns:
  The current basic_filebuf buffer.

This hides both signatures of std::basic_ios::rdbuf().

Reimplemented from std::basic_ios< CharT, Traits >.

Definition at line 828 of file fstream.

References std::basic_fstream< CharT, Traits >::open(), and std::ios_base::openmode.

template<typename CharT, typename Traits>
iostate std::basic_ios< CharT, Traits >::rdstate | ( |  | ) | const`[inline, inherited]`

Returns the error state of the stream buffer.

Returns:
  A bit pattern (well, isn't everything?)

See std::ios_base::iostate for the possible bit values. Most users will call one of the interpreting wrappers, e.g., good().

Definition at line 123 of file basic_ios.h.

Referenced by std::basic_ios< char, Traits >::bad(), std::basic_ios< CharT, Traits >::clear(), std::basic_ios< char, Traits >::eof(), std::basic_ios< char, Traits >::fail(), and std::basic_ios< char, Traits >::good().

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::read | ( | char_type * | s,
|  | streamsize | n
| ) | `[inherited]`

Extraction without delimiters.

Parameters:

  | s | A character array.
  | n | Maximum number of characters to store.

Returns:
  *this

If the stream state is `good()`, extracts characters and stores them into s until one of the following happens:

- n characters are stored
- the input sequence reaches end-of-file, in which case the error state is set to `failbit|eofbit`.

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 708 of file istream.tcc.

References std::basic_ios< CharT, Traits >::rdbuf().

template<typename CharT, typename Traits>
streamsize std::basic_istream< CharT, Traits >::readsome | ( | char_type * | s,
|  | streamsize | n
| ) | `[inherited]`

Extraction until the buffer is exhausted, but no more.

Parameters:

  | s | A character array.
  | n | Maximum number of characters to store.

Returns:
  The number of characters extracted.

Extracts characters and stores them into s depending on the number of characters remaining in the streambuf's buffer, `rdbuf()->in_avail()`, called `A` here:

- if `A` `==` `-1`, sets eofbit and extracts no characters
- if `A` `==` `0`, extracts no characters
- if `A` `>` `0`, extracts `min(A,n)`

The goal is to empty the current buffer, and to not request any more from the external input sequence controlled by the streambuf.

Definition at line 732 of file istream.tcc.

References std::basic_ios< CharT, Traits >::rdbuf(), and std::streamsize.

void std::ios_base::register_callback | ( | event_callback | __fn,
|  | int | index
| ) | `[inherited]`

Add the callback __fn with parameter index.

Parameters:

  | __fn | The function to add.
  | index | The integer to pass to the function when invoked.

Registers a function as an event callback with an integer parameter to be passed to the function when invoked. Multiple copies of the function are allowed. If there are multiple callbacks, they are invoked in the order they were registered.

Definition at line 147 of file ios.cc.

References std::ios_base::event_callback.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::seekg | ( | off_type | ,
|  | ios_base::seekdir |
| ) | `[inherited]`

Changing the current read position.

Parameters:

  | off | A file offset object.
  | dir | The direction in which to seek.

Returns:
  *this

If `fail()` is not true, calls `rdbuf()->pubseekoff(off,dir)`. If that function fails, sets failbit.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 892 of file istream.tcc.

References std::basic_ios< CharT, Traits >::fail(), std::basic_istream< CharT, Traits >::off_type, std::basic_istream< CharT, Traits >::pos_type, std::basic_ios< CharT, Traits >::rdbuf(), and std::ios_base::seekdir.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::seekg | ( | pos_type |  | ) | `[inherited]`

Changing the current read position.

Parameters:

  | pos | A file position object.

Returns:
  *this

If `fail()` is not true, calls `rdbuf()->pubseekpos(pos)`. If that function fails, sets failbit.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 864 of file istream.tcc.

References std::basic_ios< CharT, Traits >::fail(), std::basic_istream< CharT, Traits >::off_type, std::basic_istream< CharT, Traits >::pos_type, and std::basic_ios< CharT, Traits >::rdbuf().

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::seekp | ( | off_type | ,
|  | ios_base::seekdir |
| ) | `[inherited]`

Changing the current write position.

Parameters:

  | off | A file offset object.
  | dir | The direction in which to seek.

Returns:
  *this

If `fail()` is not true, calls `rdbuf()->pubseekoff(off,dir)`. If that function fails, sets failbit.

Definition at line 446 of file ostream.tcc.

References std::basic_ios< CharT, Traits >::fail(), std::basic_ostream< CharT, Traits >::off_type, std::basic_ostream< CharT, Traits >::pos_type, std::basic_ios< CharT, Traits >::rdbuf(), and std::ios_base::seekdir.

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits > & std::basic_ostream< CharT, Traits >::seekp | ( | pos_type |  | ) | `[inherited]`

Changing the current write position.

Parameters:

  | pos | A file position object.

Returns:
  *this

If `fail()` is not true, calls `rdbuf()->pubseekpos(pos)`. If that function fails, sets failbit.

Definition at line 419 of file ostream.tcc.

References std::basic_ios< CharT, Traits >::fail(), std::basic_ostream< CharT, Traits >::off_type, std::basic_ostream< CharT, Traits >::pos_type, and std::basic_ios< CharT, Traits >::rdbuf().

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl,
|  | fmtflags | __mask
| ) | `[inline, inherited]`

Setting new format flags.

Parameters:

  | fmtfl | Additional flags to set.
  | mask | The flags mask for fmtfl.

Returns:
  The previous format control flags.

This function clears mask in the format flags, then sets fmtfl `&` mask. An example mask is `ios_base::adjustfield`.

Definition at line 550 of file ios_base.h.

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl | ) | `[inline, inherited]`

Setting new format flags.

Parameters:

  | fmtfl | Additional flags to set.

Returns:
  The previous format control flags.

This function sets additional flags in format control. Flags that were previously set remain set.

Definition at line 533 of file ios_base.h.

References std::ios_base::setf().

Referenced by std::boolalpha(), std::dec(), std::fixed(), std::hex(), std::internal(), std::left(), std::oct(), std::right(), std::scientific(), std::ios_base::setf(), std::showbase(), std::showpoint(), std::showpos(), std::skipws(), std::unitbuf(), and std::uppercase().

template<typename CharT, typename Traits>
void std::basic_ios< CharT, Traits >::setstate | ( | iostate | state | ) | `[inline, inherited]`

Sets additional flags in the error state.

Parameters:

  | state | The additional state flag(s) to set.

See std::ios_base::iostate for the possible bit values.

Definition at line 143 of file basic_ios.h.

Referenced by std::getline(), std::operator>>(), std::basic_ostream< CharT, Traits >::sentry::sentry(), std::basic_istream< CharT, Traits >::sentry::sentry(), and std::ws().

template<typename CharT, typename Traits>
int std::basic_istream< CharT, Traits >::sync | ( |  | ) | `[inherited]`

Synchronizing the stream buffer.

Returns:
  0 on success, -1 on failure

If `rdbuf()` is a null pointer, returns -1.

Otherwise, calls `rdbuf()->pubsync()`, and if that returns -1, sets badbit and returns -1.

Otherwise, returns 0.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 815 of file istream.tcc.

References std::basic_ios< CharT, Traits >::rdbuf().

bool std::ios_base::sync_with_stdio | ( | bool | sync = `true` | ) | `[static, inherited]`

Interaction with the standard C I/O objects.

Parameters:

  | sync | Whether to synchronize or not.

Returns:
  True if the standard streams were previously synchronized.

The synchronization referred to is only that between the standard C facilities (e.g., stdout) and the standard C++ objects (e.g., cout). User-declared streams are unaffected. See http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#8 for more.

Definition at line 148 of file ios_init.cc.

References std::cerr, std::cin, std::clog, and std::cout.

template<typename CharT, typename Traits>
basic_istream< CharT, Traits >::pos_type std::basic_istream< CharT, Traits >::tellg | ( |  | ) | `[inherited]`

Getting the current read position.

Returns:
  A file position object.

If `fail()` is not false, returns `pos_type`(-1) to indicate failure. Otherwise returns `rdbuf()->pubseekoff(0,cur,in)`.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount()`.

Definition at line 846 of file istream.tcc.

References std::basic_ios< CharT, Traits >::fail(), std::basic_istream< CharT, Traits >::pos_type, and std::basic_ios< CharT, Traits >::rdbuf().

template<typename CharT, typename Traits>
basic_ostream< CharT, Traits >::pos_type std::basic_ostream< CharT, Traits >::tellp | ( |  | ) | `[inherited]`

Getting the current write position.

Returns:
  A file position object.

If `fail()` is not false, returns `pos_type`(-1) to indicate failure. Otherwise returns `rdbuf()->pubseekoff(0,cur,out)`.

Definition at line 403 of file ostream.tcc.

References std::basic_ios< CharT, Traits >::fail(), std::basic_ostream< CharT, Traits >::pos_type, and std::basic_ios< CharT, Traits >::rdbuf().

template<typename CharT, typename Traits>
basic_ostream<CharT, Traits>* std::basic_ios< CharT, Traits >::tie | ( | basic_ostream< CharT, Traits > * | __tiestr | ) | `[inline, inherited]`

Ties this stream to an output stream.

Parameters:

  | tiestr | The output stream.

Returns:
  The previously tied output stream, or NULL if the stream was not tied.

This sets up a new tie; see tie() for more.

Definition at line 293 of file basic_ios.h.

template<typename CharT, typename Traits>
basic_ostream<CharT, Traits>* std::basic_ios< CharT, Traits >::tie | ( |  | ) | const`[inline, inherited]`

Fetches the current tied stream.

Returns:
  A pointer to the tied stream, or NULL if the stream is not tied.

A stream may be tied (or synchronized) to a second output stream. When this stream performs any I/O, the tied stream is first flushed. For example, `std::cin` is tied to `std::cout`.

Definition at line 281 of file basic_ios.h.

Referenced by std::basic_ios< CharT, Traits >::copyfmt(), std::basic_ostream< CharT, Traits >::sentry::sentry(), and std::basic_istream< CharT, Traits >::sentry::sentry().

template<typename CharT, typename Traits>
basic_istream< CharT, Traits > & std::basic_istream< CharT, Traits >::unget | ( |  | ) | `[inherited]`

Unextracting the previous character.

Returns:
  *this

If `rdbuf()` is not null, calls `rdbuf()->sungetc(c)`.

If `rdbuf()` is null or if `sungetc()` fails, sets badbit in the error state.

Note:
  Since no characters are extracted, the next call to `gcount()` will return 0, as required by DR 60.

Definition at line 787 of file istream.tcc.

References std::basic_istream< CharT, Traits >::int_type, and std::basic_ios< CharT, Traits >::rdbuf().

void std::ios_base::unsetf | ( | fmtflags | __mask | ) | `[inline, inherited]`

Clearing format flags.

Parameters:

  | mask | The flags to unset.

This function clears mask in the format flags.

Definition at line 565 of file ios_base.h.

References std::ios_base::unsetf().

Referenced by std::noboolalpha(), std::noshowbase(), std::noshowpoint(), std::noshowpos(), std::noskipws(), std::nounitbuf(), std::nouppercase(), and std::ios_base::unsetf().

template<typename CharT, typename Traits>
CharT std::basic_ios< CharT, Traits >::widen | ( | char | c | ) | const`[inherited]`

Widens characters.

Parameters:

  | c | The character to widen.

Returns:
  The widened character.

Maps a character of `char` to a character of `char_type`.

Returns the result of

        std::use_facet<ctype<char_type> >(getloc()).widen(c)

Additional l10n notes are at http://gcc.gnu.org/onlinedocs/libstdc++/22_locale/howto.html

Definition at line 121 of file basic_ios.tcc.

Referenced by std::endl(), std::getline(), and std::operator>>().

streamsize std::ios_base::width | ( | streamsize | __wide | ) | `[inline, inherited]`

Changing flags.

Parameters:

  | wide | The new width value.

Returns:
  The previous value of width().

Definition at line 607 of file ios_base.h.

References std::streamsize.

streamsize std::ios_base::width | ( |  | ) | const`[inline, inherited]`

Flags access.

Returns:
  The minimum field width to generate on output operations.

"Minimum field width" refers to the number of characters.

Definition at line 599 of file ios_base.h.

Referenced by std::basic_ios< CharT, Traits >::copyfmt(), std::num_put< CharT, OutIter >::do_put(), and std::operator>>().

template<typename CharT, typename Traits>
__ostream_type& std::basic_ostream< CharT, Traits >::write | ( | const char_type * | s,
|  | streamsize | n
| ) | `[inherited]`

Character string insertion.

Parameters:

  | s | The array to insert.
  | n | Maximum number of characters to insert.

Returns:
  *this

Characters are copied from s and inserted into the stream until one of the following happens:

- n characters are inserted
- inserting into the output sequence fails (in this case, badbit will be set in the stream's error state)

Note:
  This function is not overloaded on signed char and unsigned char.

int std::ios_base::xalloc | ( |  | ) | throw ()`[static, inherited]`

Access to unique indices.

Returns:
  An integer different from all previous calls.

This function returns a unique integer every time it is called. It can be used for any purpose, but is primarily intended to be a unique index for the iword and pword functions. The expectation is that an application calls xalloc in order to obtain an index in the iword and pword arrays that can be used without fear of conflict.

The implementation maintains a static variable that is incremented and returned on each invocation. xalloc is guaranteed to return an index that is safe to use in the iword and pword arrays.

Definition at line 138 of file ios.cc.

## Member Data Documentation

const ios_base::fmtflags std::ios_base::adjustfield`[static, inherited]`

| A mask of left|right|internal. Useful for the 2-arg form of `setf`. Definition at line 88 of file ios.cc.

const ios_base::openmode std::ios_base::app`[static, inherited]`

| Seek to end before each write. Definition at line 97 of file ios.cc.

const ios_base::openmode std::ios_base::ate`[static, inherited]`

| Open and seek to end immediately after opening. Definition at line 98 of file ios.cc.

const ios_base::iostate std::ios_base::badbit`[static, inherited]`

| Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file). Definition at line 92 of file ios.cc.

const ios_base::fmtflags std::ios_base::basefield`[static, inherited]`

| A mask of dec|oct|hex. Useful for the 2-arg form of `setf`. Definition at line 89 of file ios.cc.

const ios_base::seekdir std::ios_base::beg`[static, inherited]`

| Request a seek relative to the beginning of the stream. Definition at line 104 of file ios.cc.

const ios_base::openmode std::ios_base::binary`[static, inherited]`

| Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#3 and http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#7 for more. Definition at line 99 of file ios.cc.

const ios_base::fmtflags std::ios_base::boolalpha`[static, inherited]`

| Insert/extract `bool` in alphabetic rather than numeric format. Definition at line 73 of file ios.cc.

const ios_base::seekdir std::ios_base::cur`[static, inherited]`

| Request a seek relative to the current position within the sequence. Definition at line 105 of file ios.cc.

const ios_base::fmtflags std::ios_base::dec`[static, inherited]`

| Converts integer input or generates integer output in decimal base. Definition at line 74 of file ios.cc.

const ios_base::seekdir std::ios_base::end`[static, inherited]`

| Request a seek relative to the current end of the sequence. Definition at line 106 of file ios.cc.

const ios_base::iostate std::ios_base::eofbit`[static, inherited]`

| Indicates that an input operation reached the end of an input sequence. Definition at line 93 of file ios.cc.

const ios_base::iostate std::ios_base::failbit`[static, inherited]`

| Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters. Definition at line 94 of file ios.cc.

const ios_base::fmtflags std::ios_base::fixed`[static, inherited]`

| Generate floating-point output in fixed-point notation. Definition at line 75 of file ios.cc.

const ios_base::fmtflags std::ios_base::floatfield`[static, inherited]`

| A mask of scientific|fixed. Useful for the 2-arg form of `setf`. Definition at line 90 of file ios.cc.

const ios_base::iostate std::ios_base::goodbit`[static, inherited]`

| Indicates all is well. Definition at line 95 of file ios.cc.

const ios_base::fmtflags std::ios_base::hex`[static, inherited]`

| Converts integer input or generates integer output in hexadecimal base. Definition at line 76 of file ios.cc.

const ios_base::openmode std::ios_base::in`[static, inherited]`

| Open for input. Default for `ifstream` and fstream. Definition at line 100 of file ios.cc.

const ios_base::fmtflags std::ios_base::internal`[static, inherited]`

| Adds fill characters at a designated internal point in certain generated output, or identical to `right` if no such point is designated. Definition at line 77 of file ios.cc.

const ios_base::fmtflags std::ios_base::left`[static, inherited]`

| Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.). Definition at line 78 of file ios.cc.

const ios_base::fmtflags std::ios_base::oct`[static, inherited]`

| Converts integer input or generates integer output in octal base. Definition at line 79 of file ios.cc.

const ios_base::openmode std::ios_base::out`[static, inherited]`

| Open for output. Default for `ofstream` and fstream. Definition at line 101 of file ios.cc.

const ios_base::fmtflags std::ios_base::right`[static, inherited]`

| Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.). Definition at line 80 of file ios.cc.

const ios_base::fmtflags std::ios_base::scientific`[static, inherited]`

| Generates floating-point output in scientific notation. Definition at line 81 of file ios.cc.

const ios_base::fmtflags std::ios_base::showbase`[static, inherited]`

| Generates a prefix indicating the numeric base of generated integer output. Definition at line 82 of file ios.cc.

const ios_base::fmtflags std::ios_base::showpoint`[static, inherited]`

| Generates a decimal-point character unconditionally in generated floating-point output. Definition at line 83 of file ios.cc.

const ios_base::fmtflags std::ios_base::showpos`[static, inherited]`

| Generates a + sign in non-negative generated numeric output. Definition at line 84 of file ios.cc.

const ios_base::fmtflags std::ios_base::skipws`[static, inherited]`

| Skips leading white space before certain input operations. Definition at line 85 of file ios.cc.

const ios_base::openmode std::ios_base::trunc`[static, inherited]`

| Open for input. Default for `ofstream`. Definition at line 102 of file ios.cc.

const ios_base::fmtflags std::ios_base::unitbuf`[static, inherited]`

| Flushes output after each output operation. Definition at line 86 of file ios.cc.

const ios_base::fmtflags std::ios_base::uppercase`[static, inherited]`

| Replaces certain lowercase letters with their uppercase equivalents in generated output. Definition at line 87 of file ios.cc.

The documentation for this class was generated from the following file:

- fstream